// David Eberly, Geometric Tools, Redmond WA 98052
// Copyright (c) 1998-2024
// Distributed under the Boost Software License, Version 1.0.
// https://www.boost.org/LICENSE_1_0.txt
// https://www.geometrictools.com/License/Boost/LICENSE_1_0.txt
// Version: 6.0.2022.01.06

#pragma once

// Mathematics/GPU/ComputationalGeometry
#include <MathematicsGPU/GPUGenerateMeshUV.h>

// Mathematics/GPU/Physics/Fluids2
#include <MathematicsGPU/GPUFluid2.h>
#include <MathematicsGPU/GPUFluid2AdjustVelocity.h>
#include <MathematicsGPU/GPUFluid2ComputeDivergence.h>
#include <MathematicsGPU/GPUFluid2EnforceStateBoundary.h>
#include <MathematicsGPU/GPUFluid2InitializeSource.h>
#include <MathematicsGPU/GPUFluid2InitializeState.h>
#include <MathematicsGPU/GPUFluid2Parameters.h>
#include <MathematicsGPU/GPUFluid2SolvePoisson.h>
#include <MathematicsGPU/GPUFluid2UpdateState.h>

// Mathematics/GPU/Physics/Fluids3
#include <MathematicsGPU/GPUFluid3.h>
#include <MathematicsGPU/GPUFluid3AdjustVelocity.h>
#include <MathematicsGPU/GPUFluid3ComputeDivergence.h>
#include <MathematicsGPU/GPUFluid3EnforceStateBoundary.h>
#include <MathematicsGPU/GPUFluid3InitializeSource.h>
#include <MathematicsGPU/GPUFluid3InitializeState.h>
#include <MathematicsGPU/GPUFluid3Parameters.h>
#include <MathematicsGPU/GPUFluid3SolvePoisson.h>
#include <MathematicsGPU/GPUFluid3UpdateState.h>
